var canvas = document.getElementById("drawing");
let ctx = canvas.getContext("2d");
const w = canvas.width;
const h = canvas.height;
let an;

ctx.translate(20, 15);
ctx.scale(0.95, 0.95);
let n = 0;
let k = 14;
let s_ang = 0;
let p = [];
let s1 = 1;
let cx = w / 2,
  cy = h / 2;
p.push({ x: w / 2, y: h / 2 + 10 });
p.push({ x: w / 2, y: h / 2 });

play();
function clear(arr) {
  let maxx = Math.max(...arr.map((o) => o.x));
  let minx = Math.min(...arr.map((o) => o.x));
  let maxy = Math.max(...arr.map((o) => o.y));
  let miny = Math.min(...arr.map((o) => o.y));

  ctx.clearRect(-4*maxx, -4*maxy, 8*maxx, 8*maxy,);
}
function drawline(arr, color) {
  ctx.strokeStyle = color;
  ctx.beginPath();
  ctx.moveTo(arr[0].x, arr[0].y);
  for (var i = 1; i < arr.length; i++) {
    ctx.lineTo(arr[i].x, arr[i].y);
  }
  ctx.stroke();
}
function get_s(arr) {
  let maxx = Math.max(...arr.map((o) => o.x));
  let minx = Math.min(...arr.map((o) => o.x));
  let maxy = Math.max(...arr.map((o) => o.y));
  let miny = Math.min(...arr.map((o) => o.y));

  ctx.translate(cx, cy);
  cx = (maxx - minx) / 2 + minx;
  cy = (maxy - miny) / 2 + miny;
  ctx.translate(-cx, -cy);
  let s = Math.min(w / (maxx - minx), h / (maxy - miny));
  return s;
}
function scale(s) {
  let tx = cx;
  let ty = cy;
  ctx.translate(tx - s * cx, ty - s * cy);
  cx = tx;
  cy = ty;
  ctx.scale(s, s);
}
function render() {
  let t = pw(2, n);
  let tx = p[t].x,
    ty = p[t].y;

  p.forEach(function (item, i, arr) {
    item.x -= tx;
    item.y -= ty;
  });

  let p1 = [];
  p.forEach(function (item, i, arr) {
    var rx = item.x;
    var ry = item.y;
    p1.push({
      x: rx * cosd(-s_ang) - ry * sind(-s_ang),
      y: rx * sind(-s_ang) + ry * cosd(-s_ang)
    });
  });

  if (s_ang == 90) {
    p1.pop();
    p1.reverse();
    p = p.concat(p1);
  } else {
    p1.reverse();
    p1.forEach(function (item, i, arr) {
      item.x += tx;
      item.y += ty;
    });
  }

  p.forEach(function (item, i, arr) {
    item.x += tx;
    item.y += ty;
  });

  var s = get_s(p.concat(p1));
  clear(p.concat(p1));
  scale(s / s1);
  s1 = s;

  drawline(p, "black");
  if (s_ang != 90) drawline(p1, "blue");
}
function play() {
  render();
  if (s_ang == 90) {
    s_ang = 0;
    n++;
  } else s_ang++;

  if (n != k) an = requestAnimationFrame(play);
  else {
    cancelAnimationFrame(an);
    an = null;
  }
}
function cosd(dg) {
  return Math.cos((dg * Math.PI) / 180);
}
function sind(dg) {
  return Math.sin((dg * Math.PI) / 180);
}
function pw(w, v) {
  return Math.pow(w, v);
}
